diff --git a/src/dbus-objects/model.h b/src/dbus-objects/model.h
index c3263fd00..a114d5b3e 100644
--- a/src/dbus-objects/model.h
+++ b/src/dbus-objects/model.h
@@ -188,14 +188,40 @@ extern dbus_bool_t		__ni_objectmodel_get_domain_string(const ni_dbus_variant_t *
 extern dbus_bool_t		__ni_objectmodel_set_resolver_dict(ni_resolver_info_t **,
 						const ni_dbus_variant_t *, DBusError *);
 
-extern dbus_bool_t		__ni_objectmodel_get_team_port_config(const ni_team_port_config_t *,
+extern dbus_bool_t		ni_objectmodel_get_bonding_port_info(const ni_bonding_port_info_t *,
 						ni_dbus_variant_t *, DBusError *);
-extern dbus_bool_t		__ni_objectmodel_set_team_port_config(ni_team_port_config_t *,
+extern dbus_bool_t		ni_objectmodel_set_bonding_port_info(ni_bonding_port_info_t *,
+						const ni_dbus_variant_t *, DBusError *);
+extern dbus_bool_t		ni_objectmodel_get_bonding_port_config(const ni_bonding_port_config_t *,
+						ni_dbus_variant_t *, DBusError *);
+extern dbus_bool_t		ni_objectmodel_set_bonding_port_config(ni_bonding_port_config_t *,
+						const ni_dbus_variant_t *, DBusError *);
+
+extern dbus_bool_t		ni_objectmodel_get_team_port_info(const ni_team_port_info_t *,
+						ni_dbus_variant_t *, DBusError *);
+extern dbus_bool_t		ni_objectmodel_set_team_port_info(ni_team_port_info_t *,
+						const ni_dbus_variant_t *, DBusError *);
+extern dbus_bool_t		ni_objectmodel_get_team_port_config(const ni_team_port_config_t *,
+						ni_dbus_variant_t *, DBusError *);
+extern dbus_bool_t		ni_objectmodel_set_team_port_config(ni_team_port_config_t *,
 						const ni_dbus_variant_t *, DBusError *);
 
-extern dbus_bool_t		__ni_objectmodel_get_ovs_bridge_port_config(const ni_ovs_bridge_port_config_t *,
+extern dbus_bool_t		ni_objectmodel_get_bridge_port_info(const ni_bridge_port_info_t *,
+						ni_dbus_variant_t *, DBusError *);
+extern dbus_bool_t		ni_objectmodel_set_bridge_port_info(ni_bridge_port_info_t *,
+						const ni_dbus_variant_t *, DBusError *);
+extern dbus_bool_t		ni_objectmodel_get_bridge_port_config(const ni_bridge_port_config_t *,
+						ni_dbus_variant_t *, DBusError *);
+extern dbus_bool_t		ni_objectmodel_set_bridge_port_config(ni_bridge_port_config_t *,
+						const ni_dbus_variant_t *, DBusError *);
+
+extern dbus_bool_t		ni_objectmodel_get_ovs_bridge_port_info(const ni_ovs_bridge_port_info_t *,
+						ni_dbus_variant_t *, DBusError *);
+extern dbus_bool_t		ni_objectmodel_set_ovs_bridge_port_info(ni_ovs_bridge_port_info_t *,
+						const ni_dbus_variant_t *, DBusError *);
+extern dbus_bool_t		ni_objectmodel_get_ovs_bridge_port_config(const ni_ovs_bridge_port_config_t *,
 						ni_dbus_variant_t *, DBusError *);
-extern dbus_bool_t		__ni_objectmodel_set_ovs_bridge_port_config(ni_ovs_bridge_port_config_t *,
+extern dbus_bool_t		ni_objectmodel_set_ovs_bridge_port_config(ni_ovs_bridge_port_config_t *,
 						const ni_dbus_variant_t *, DBusError *);
 
 extern dbus_bool_t		ni_objectmodel_bind_netdev_ref_index(const char *, const char *,
diff --git a/src/dbus-objects/ovs.c b/src/dbus-objects/ovs.c
index b64beb903..d9a4fb8e0 100644
--- a/src/dbus-objects/ovs.c
+++ b/src/dbus-objects/ovs.c
@@ -250,135 +250,52 @@ ni_objectmodel_get_ovs_bridge(const ni_dbus_object_t *object, ni_bool_t write_ac
 #endif
 
 /*
- * OVS Bridge port config helpers
+ * OVS Bridge interface info properties <-> dict
  */
-/* extern */ dbus_bool_t
-__ni_objectmodel_get_ovs_bridge_port_config(const ni_ovs_bridge_port_config_t *pconf, ni_dbus_variant_t *dict, DBusError *error)
+extern dbus_bool_t
+ni_objectmodel_get_ovs_bridge_port_info(const ni_ovs_bridge_port_info_t *info,
+		ni_dbus_variant_t *dict, DBusError *error)
 {
 	(void)error;
 
-	if (!pconf || !dict)
+	if (!info || !dict)
 		return FALSE;
 
-	if (!ni_string_empty(pconf->bridge.name))
-		ni_dbus_dict_add_string(dict, "bridge", pconf->bridge.name);
-
 	return TRUE;
 }
-
-/* extern */ dbus_bool_t
-__ni_objectmodel_set_ovs_bridge_port_config(ni_ovs_bridge_port_config_t *pconf, const ni_dbus_variant_t *dict, DBusError *error)
+extern dbus_bool_t
+ni_objectmodel_set_ovs_bridge_port_info(ni_ovs_bridge_port_info_t *info,
+		const ni_dbus_variant_t *dict, DBusError *error)
 {
-	const char *string;
+	(void)error;
 
-	if (!pconf || !dict)
+	if (!info || !dict)
 		return FALSE;
 
-	if (ni_dbus_dict_get_string(dict, "bridge", &string) && !ni_string_empty(string))
-		ni_netdev_ref_set_ifname(&pconf->bridge, string);
-
 	return TRUE;
 }
 
 /*
- * Property ports (array)
+ * OVS Bridge (link-request) port configuration <-> dict
  */
-static dbus_bool_t
-__ni_objectmodel_ovs_bridge_port_to_dict(const ni_ovs_bridge_port_t *port, ni_dbus_variant_t *dict, DBusError *error)
-{
-	(void)error;
-
-	if (!port || !dict)
-		return FALSE;
-
-	ni_dbus_dict_add_string(dict, "device", port->device.name);
-
-	return TRUE;
-}
-
-static dbus_bool_t
-__ni_objectmodel_ovs_bridge_get_ports(const ni_dbus_object_t *object, const ni_dbus_property_t *property,
-					ni_dbus_variant_t *result, DBusError *error)
-{
-	ni_dbus_variant_t *dict;
-	const ni_ovs_bridge_t *ovsbr;
-	unsigned int i;
-
-	ni_dbus_dict_array_init(result);
-
-	if (!(ovsbr = __ni_objectmodel_ovs_bridge_read_handle(object, error)))
-		return ni_dbus_error_property_not_present(error, object->path, property->name);
-
-	for (i = 0; i < ovsbr->ports.count; ++i) {
-		const ni_ovs_bridge_port_t *port = ovsbr->ports.data[i];
-
-		if (!port || ni_string_empty(port->device.name))
-			continue;
-
-		if (!(dict = ni_dbus_dict_array_add(result)))
-			return FALSE;
-
-		ni_dbus_variant_init_dict(dict);
-		if (!__ni_objectmodel_ovs_bridge_port_to_dict(port, dict, error))
-			return FALSE;
-	}
-	return TRUE;
-}
-
-static dbus_bool_t
-__ni_objectmodel_ovs_bridge_port_from_dict(ni_ovs_bridge_port_t *port, const ni_dbus_variant_t *dict, DBusError *error)
+extern dbus_bool_t
+ni_objectmodel_get_ovs_bridge_port_config(const ni_ovs_bridge_port_config_t *conf,
+		ni_dbus_variant_t *dict, DBusError *error)
 {
-	const char *string;
-
 	(void)error;
 
-	if (!port || !dict)
+	if (!conf || !dict)
 		return FALSE;
 
-	if (!ni_dbus_variant_is_dict(dict))
-		return FALSE;
-
-	if (!ni_dbus_dict_get_string(dict, "device", &string) || ni_string_empty(string))
-		return FALSE;
-
-	ni_netdev_ref_set_ifname(&port->device, string);
 	return TRUE;
 }
-
-static dbus_bool_t
-__ni_objectmodel_ovs_bridge_set_ports(ni_dbus_object_t *object, const ni_dbus_property_t *property,
-					const ni_dbus_variant_t *argument, DBusError *error)
+extern dbus_bool_t
+ni_objectmodel_set_ovs_bridge_port_config(ni_ovs_bridge_port_config_t *conf,
+		const ni_dbus_variant_t *dict, DBusError *error)
 {
-	const ni_dbus_variant_t *dict;
-	ni_ovs_bridge_t *ovsbr;
-	unsigned  int i;
-
-	if (!ni_dbus_variant_is_dict_array(argument))
-		return FALSE;
-
-	if (!(ovsbr = __ni_objectmodel_ovs_bridge_write_handle(object, error)))
+	if (!conf || !dict)
 		return FALSE;
 
-	/* note: property refresh may call it on a ovsbr that contains ports */
-	ni_ovs_bridge_port_array_destroy(&ovsbr->ports);
-	for (i = 0; i < argument->array.len; ++i) {
-		ni_ovs_bridge_port_t *port;
-
-		port = ni_ovs_bridge_port_new();
-		dict = &argument->variant_array_value[i];
-		if (!__ni_objectmodel_ovs_bridge_port_from_dict(port, dict, error)) {
-			ni_ovs_bridge_port_free(port);
-			return FALSE;
-		}
-		if (ni_ovs_bridge_port_array_find_by_name(&ovsbr->ports, port->device.name)) {
-			ni_ovs_bridge_port_free(port);
-			continue;
-		}
-		if (!ni_ovs_bridge_port_array_append(&ovsbr->ports, port)) {
-			ni_ovs_bridge_port_free(port);
-			return FALSE;
-		}
-	}
 	return TRUE;
 }
 
@@ -442,7 +359,7 @@ __ni_objectmodel_ovs_bridge_set_vlan(ni_dbus_object_t *object, const ni_dbus_pro
 
 static ni_dbus_property_t	ni_objectmodel_ovs_bridge_properties[] = {
 	OVS_BRIDGE_DICT_PROPERTY(vlan, vlan, RO),
-	OVS_BRIDGE_DICT_ARRAY_PROPERTY(ports, ports, RO),
+
 	{ NULL }
 };
 
diff --git a/src/dbus-objects/team.c b/src/dbus-objects/team.c
index 0fb9e931a..7097ebae8 100644
--- a/src/dbus-objects/team.c
+++ b/src/dbus-objects/team.c
@@ -279,14 +279,6 @@ __ni_objectmodel_team_read_handle(const ni_dbus_object_t *object, DBusError *err
 	return ni_objectmodel_get_team(object, FALSE, error);
 }
 
-#if 0
-static void *
-ni_objectmodel_get_team(const ni_dbus_object_t *object, ni_bool_t write_access, DBusError *error)
-{
-	return __ni_objectmodel_team_handle(object, write_access, error);
-}
-#endif
-
 static dbus_bool_t
 __ni_objectmodel_team_get_address(const ni_dbus_object_t *object, const ni_dbus_property_t *property,
 				ni_dbus_variant_t *result, DBusError *error)
@@ -823,160 +815,206 @@ __ni_objectmodel_team_set_link_watch(ni_dbus_object_t *object, const ni_dbus_pro
 /*
  * Helper function for team port config as dict
  */
-/* extern */ dbus_bool_t
-__ni_objectmodel_get_team_port_config(const ni_team_port_config_t *pconf, ni_dbus_variant_t *dict, DBusError *error)
+extern dbus_bool_t
+ni_objectmodel_get_team_port_config(const ni_team_port_config_t *conf,
+		ni_dbus_variant_t *dict, DBusError *error)
 {
 	(void)error;
 
-	if (!pconf || !dict)
+	if (!conf || !dict)
 		return FALSE;
 
-	if (pconf->queue_id != -1U)
-		ni_dbus_dict_add_uint32(dict, "queue_id", pconf->queue_id);
+	if (conf->queue_id != -1U)
+		ni_dbus_dict_add_uint32(dict, "queue_id", conf->queue_id);
 
-	if (pconf->ab.prio)
-		ni_dbus_dict_add_uint32(dict, "prio", pconf->ab.prio);
-	if (pconf->ab.sticky)
-		ni_dbus_dict_add_bool(dict, "sticky", pconf->ab.sticky);
+	if (conf->ab.prio)
+		ni_dbus_dict_add_uint32(dict, "prio", conf->ab.prio);
+	if (conf->ab.sticky)
+		ni_dbus_dict_add_bool(dict, "sticky", conf->ab.sticky);
 
-	if (pconf->lacp.prio)
-		ni_dbus_dict_add_uint32(dict, "lacp_prio", pconf->lacp.prio);
-	if (pconf->lacp.key)
-		ni_dbus_dict_add_uint32(dict, "lacp_key", pconf->lacp.key);
+	if (conf->lacp.prio)
+		ni_dbus_dict_add_uint32(dict, "lacp_prio", conf->lacp.prio);
+	if (conf->lacp.key)
+		ni_dbus_dict_add_uint32(dict, "lacp_key", conf->lacp.key);
 
 	return TRUE;
 }
 
-/* extern */ dbus_bool_t
-__ni_objectmodel_set_team_port_config(ni_team_port_config_t *pconf, const ni_dbus_variant_t *dict, DBusError *error)
+extern dbus_bool_t
+ni_objectmodel_set_team_port_config(ni_team_port_config_t *conf,
+		const ni_dbus_variant_t *dict, DBusError *error)
 {
 	dbus_bool_t b;
 	uint32_t u32;
 
 	(void)error;
 
-	if (!pconf || !dict)
+	if (!conf || !dict)
 		return FALSE;
 
 	if (ni_dbus_dict_get_uint32(dict, "queue_id", &u32))
-		pconf->queue_id = u32;
+		conf->queue_id = u32;
 
 	if (ni_dbus_dict_get_uint32(dict, "prio", &u32))
-		pconf->ab.prio = u32;
+		conf->ab.prio = u32;
 	if (ni_dbus_dict_get_bool(dict, "sticky", &b))
-		pconf->ab.sticky = b;
+		conf->ab.sticky = b;
 
 	if (ni_dbus_dict_get_uint32(dict, "lacp_prio", &u32))
-		pconf->lacp.prio = u32;
+		conf->lacp.prio = u32;
 
 	if (ni_dbus_dict_get_uint32(dict, "lacp_key", &u32))
-		pconf->lacp.key = u32;
+		conf->lacp.key = u32;
 
 	return TRUE;
 }
 
 /*
- * Helper function for team port device as dict
+ * team port interface info properties <-> dict
  */
-static dbus_bool_t
-__ni_objectmodel_team_port_to_dict(const ni_team_port_t *port, ni_dbus_variant_t *dict, DBusError *error)
+static inline dbus_bool_t
+ni_objectmodel_get_team_port_runner_lacp_info(const ni_team_port_runner_lacp_info_t *lacp,
+		ni_dbus_variant_t *dict)
 {
-	(void)error;
+	ni_dbus_dict_add_uint16(dict, "aggregator-id", lacp->aggregator.id);
+	ni_dbus_dict_add_bool(dict,   "selected",  lacp->selected);
+	ni_dbus_dict_add_string(dict, "state",  lacp->state);
+
+	return TRUE;
+}
+
+static inline dbus_bool_t
+ni_objectmodel_get_team_port_runner_info(const ni_team_port_runner_info_t *runner,
+		ni_dbus_variant_t *dict)
+{
+	ni_dbus_variant_t *rdict;
+	ni_dbus_variant_t *ldict;
+	const char *name;
 
-	if (!port || !dict || ni_string_empty(port->device.name))
+	if (!(name = ni_team_runner_type_to_name(runner->type)))
 		return FALSE;
 
-	ni_dbus_dict_add_string(dict, "device", port->device.name);
+	if (!(rdict = ni_dbus_dict_add(dict, "runner")))
+		return FALSE;
 
-	return __ni_objectmodel_get_team_port_config(&port->config, dict, error);
-}
+	ni_dbus_variant_init_struct(rdict);
+	ni_dbus_struct_add_string(rdict, name);
+	if (!(ldict = ni_dbus_struct_add(rdict)))
+		return FALSE;
 
-static dbus_bool_t
-__ni_objectmodel_team_port_from_dict(ni_team_port_t *port, const ni_dbus_variant_t *dict, DBusError *error)
+	ni_dbus_variant_init_dict(ldict);
+	switch (runner->type) {
+	case NI_TEAM_RUNNER_LACP:
+		ni_objectmodel_get_team_port_runner_lacp_info(&runner->lacp, ldict);
+		break;
+	default:
+		/* other runner types don't have any port specific info */
+		break;
+	}
+	return TRUE;
+}
+static inline dbus_bool_t
+ni_objectmodel_get_team_port_link_watches_info(const ni_team_port_link_watches_info_t *watches,
+		ni_dbus_variant_t *dict)
 {
-	const char *string;
-
-	(void)error;
+	ni_dbus_variant_t *wdict;
 
-	if (!port || !dict)
+	if (!(wdict = ni_dbus_dict_add(dict, "link_watches")))
 		return FALSE;
 
-	if (dict->array.len == 0)
-		return TRUE;
+	ni_dbus_variant_init_dict(wdict);
+	ni_dbus_dict_add_bool(wdict, "up", watches->up);
+	return TRUE;
+}
+extern dbus_bool_t
+ni_objectmodel_get_team_port_info(const ni_team_port_info_t *info,
+		ni_dbus_variant_t *dict, DBusError *error)
+{
+	(void)error;
 
-	if (ni_dbus_dict_get_string(dict, "device", &string) && !ni_string_empty(string))
-		ni_netdev_ref_set_ifname(&port->device, string);
-	else
+	if (!info || !dict)
 		return FALSE;
 
-	ni_team_port_config_init(&port->config);
-	return __ni_objectmodel_set_team_port_config(&port->config, dict, error);
+	ni_objectmodel_get_team_port_runner_info(&info->runner, dict);
+	ni_objectmodel_get_team_port_link_watches_info(&info->watches, dict);
+	return TRUE;
 }
 
-/*
- * Property ports (array)
- */
-static dbus_bool_t
-__ni_objectmodel_team_get_ports(const ni_dbus_object_t *object, const ni_dbus_property_t *property,
-				ni_dbus_variant_t *result, DBusError *error)
+static inline dbus_bool_t
+ni_objectmodel_set_team_port_runner_lacp_info(ni_team_port_runner_lacp_info_t *lacp,
+		const ni_dbus_variant_t *dict)
 {
-	ni_dbus_variant_t *dict;
-	const ni_team_t *team;
-	unsigned int i;
+	const char *str;
+	dbus_bool_t bv;
+	uint16_t u16;
 
-	if (!(team = __ni_objectmodel_team_read_handle(object, error)))
-		return FALSE;
+	if (ni_dbus_dict_get_uint16(dict, "aggregator-id", &u16))
+		lacp->aggregator.id = u16;
 
-	ni_dbus_dict_array_init(result);
-	for (i = 0; i < team->ports.count; ++i) {
-		const ni_team_port_t *port = team->ports.data[i];
+	if (ni_dbus_dict_get_bool(dict,   "selected", &bv))
+		lacp->selected = bv;
 
-		if (!(dict = ni_dbus_dict_array_add(result)))
-			return FALSE;
+	if (ni_dbus_dict_get_string(dict, "state", &str))
+		ni_string_dup(&lacp->state, str);
 
-		ni_dbus_variant_init_dict(dict);
-		if (!__ni_objectmodel_team_port_to_dict(port, dict, error))
-			return FALSE;
-	}
 	return TRUE;
 }
-
-static dbus_bool_t
-__ni_objectmodel_team_set_ports(ni_dbus_object_t *object, const ni_dbus_property_t *property,
-				const ni_dbus_variant_t *argument, DBusError *error)
+static inline dbus_bool_t
+ni_objectmodel_set_team_port_runner_info(ni_team_port_runner_info_t *runner,
+		const ni_dbus_variant_t *dict)
 {
-	const ni_dbus_variant_t *dict;
-	ni_team_t *team;
-	unsigned int i;
+	const ni_dbus_variant_t *rdict;
+	const ni_dbus_variant_t *ldict;
+	const char *name;
 
-	if (!(team = __ni_objectmodel_team_write_handle(object, error)))
+	if (!(rdict = ni_dbus_dict_get(dict, "runner")))
 		return FALSE;
 
-	if (!ni_dbus_variant_is_dict_array(argument))
+	if (!ni_dbus_struct_get_string(rdict, 0, &name))
 		return FALSE;
 
-	/* note: property refresh may call it on a team that contains ports */
-	ni_team_port_array_destroy(&team->ports);
-	for (i = 0; i < argument->array.len; ++i) {
-		ni_team_port_t *port;
+	if (!ni_team_runner_name_to_type(name, &runner->type))
+		return FALSE;
 
-		port = ni_team_port_new();
-		dict = &argument->variant_array_value[i];
-		if (!__ni_objectmodel_team_port_from_dict(port, dict, error)) {
-			ni_team_port_free(port);
-			return FALSE;
-		}
-		if (ni_team_port_array_find_by_name(&team->ports, port->device.name)) {
-			ni_team_port_free(port);
-			continue;
-		}
-		if (!ni_team_port_array_append(&team->ports, port)) {
-			ni_team_port_free(port);
-			return FALSE;
-		}
+	switch (runner->type) {
+	case NI_TEAM_RUNNER_LACP:
+		if ((ldict = ni_dbus_struct_get(rdict, 1)))
+			ni_objectmodel_set_team_port_runner_lacp_info(&runner->lacp, ldict);
+		break;
+	default:
+		/* other runner types don't have any port specific info */
+		break;
 	}
 	return TRUE;
 }
+static inline dbus_bool_t
+ni_objectmodel_set_team_port_link_watches_info(ni_team_port_link_watches_info_t *watches,
+		const ni_dbus_variant_t *dict)
+{
+	const ni_dbus_variant_t *wdict;
+	dbus_bool_t bval;
+
+	if (!(wdict = ni_dbus_dict_get(dict, "link_watches")))
+		return FALSE;
+
+	if (ni_dbus_dict_get_bool(wdict, "up", &bval))
+		watches->up = bval;
+
+	return TRUE;
+}
+extern dbus_bool_t
+ni_objectmodel_set_team_port_info(ni_team_port_info_t *info,
+		const ni_dbus_variant_t *dict, DBusError *error)
+{
+	(void)error;
+
+	if (!info || !dict)
+		return FALSE;
+
+	ni_objectmodel_set_team_port_runner_info(&info->runner, dict);
+	ni_objectmodel_set_team_port_link_watches_info(&info->watches, dict);
+	return TRUE;
+}
 
 #define TEAM_HWADDR_PROPERTY(dbus_name, rw) \
 	__NI_DBUS_PROPERTY(DBUS_TYPE_ARRAY_AS_STRING DBUS_TYPE_BYTE_AS_STRING, \
@@ -998,7 +1036,7 @@ static ni_dbus_property_t	ni_objectmodel_team_properties[] = {
 	TEAM_DICT_PROPERTY(runner, runner, RO),
 	TEAM_UINT_PROPERTY(link_watch_policy, link_watch_policy, RO),
 	TEAM_DICT_PROPERTY(link_watch, link_watch, RO),
-	TEAM_DICT_ARRAY_PROPERTY(ports, ports, RO),
+
 	TEAM_HWADDR_PROPERTY(address, RO),
 
 	{ NULL }
diff --git a/src/dbus-xml.c b/src/dbus-xml.c
index 4c5560972..b85ab4423 100644
--- a/src/dbus-xml.c
+++ b/src/dbus-xml.c
@@ -50,8 +50,8 @@ static dbus_bool_t	ni_dbus_deserialize_xml_array(const ni_dbus_variant_t *, cons
 static dbus_bool_t	ni_dbus_deserialize_xml_dict(const ni_dbus_variant_t *, const ni_xs_type_t *, xml_node_t *);
 static char *		__ni_xs_type_to_dbus_signature(const ni_xs_type_t *, char *, size_t);
 static char *		ni_xs_type_to_dbus_signature(const ni_xs_type_t *);
-static ni_xs_service_t *ni_dbus_xml_get_service_schema(const ni_xs_scope_t *, const char *);
-static ni_xs_type_t *	ni_dbus_xml_get_properties_schema(const ni_xs_scope_t *, const ni_xs_service_t *);
+extern ni_xs_service_t *ni_dbus_xml_get_service_schema(const ni_xs_scope_t *, const char *);
+extern ni_xs_type_t *	ni_dbus_xml_get_properties_schema(const ni_xs_scope_t *, const ni_xs_service_t *);
 
 static ni_tempstate_t *	__ni_dbus_xml_global_temp_state;
 
@@ -1783,7 +1783,7 @@ ni_dbus_define_xml_notations(void)
 /*
  * Helper functions
  */
-static ni_xs_service_t *
+ni_xs_service_t *
 ni_dbus_xml_get_service_schema(const ni_xs_scope_t *scope, const char *interface_name)
 {
 	ni_xs_service_t *service;
@@ -1796,7 +1796,7 @@ ni_dbus_xml_get_service_schema(const ni_xs_scope_t *scope, const char *interface
 	return NULL;
 }
 
-static ni_xs_type_t *
+ni_xs_type_t *
 ni_dbus_xml_get_properties_schema(const ni_xs_scope_t *scope, const ni_xs_service_t *service)
 {
 	scope = ni_xs_scope_lookup_scope(scope, service->name);
@@ -1949,6 +1949,167 @@ ni_dbus_xml_get_method_metadata(const ni_dbus_method_t *method, const char *name
 	return count;
 }
 
+/*
+ * Traverse (system) property tree of the given service
+ * and process with user specified callback ...
+ */
+static dbus_bool_t	ni_dbus_xml_traverse(const ni_xs_type_t *, const char *,
+					const ni_dbus_xml_traverse_path_t *,
+					ni_dbus_xml_traverse_context_t *);
+
+static inline dbus_bool_t
+ni_dbus_xml_traverse_struct(const ni_xs_type_t *type, const char *name,
+		const ni_dbus_xml_traverse_path_t *path,
+		ni_dbus_xml_traverse_context_t *context)
+{
+	ni_error("%s: not implemented yet", __func__);
+	return FALSE;
+}
+
+static inline dbus_bool_t
+ni_dbus_xml_traverse_union(const ni_xs_type_t *type, const char *name,
+		const ni_dbus_xml_traverse_path_t *path,
+		ni_dbus_xml_traverse_context_t *context)
+{
+	const ni_xs_union_info_t *info;
+	unsigned int i;
+
+	info = ni_xs_union_info(type);
+	for (i = 0; i < info->children.count; ++i) {
+		const ni_xs_name_type_t *child = &info->children.data[i];
+
+		if (!child->type)
+			continue;
+
+		if (!ni_dbus_xml_traverse(child->type, child->name,
+				path, context))
+			return FALSE;
+	}
+	return TRUE;
+}
+
+static inline dbus_bool_t
+ni_dbus_xml_traverse_array(const ni_xs_type_t *type, const char *name,
+		const ni_dbus_xml_traverse_path_t *path,
+		ni_dbus_xml_traverse_context_t *context)
+{
+	const ni_xs_array_info_t *info;
+	const char *element_name;
+
+	info = ni_xs_array_info(type);
+	element_name = info->element_name ?: "e";
+	return ni_dbus_xml_traverse(info->element_type, element_name,
+			path, context);
+}
+
+static inline dbus_bool_t
+ni_dbus_xml_traverse_dict(const ni_xs_type_t *type, const char *name,
+		const ni_dbus_xml_traverse_path_t *path,
+		ni_dbus_xml_traverse_context_t *context)
+{
+	const ni_xs_dict_info_t *info;
+	unsigned int i;
+
+	info = ni_xs_dict_info(type);
+	for (i = 0; i < info->children.count; ++i) {
+		const ni_xs_name_type_t *child = &info->children.data[i];
+
+		if (!child->type) /* same as in validate … */
+			continue;
+
+		if (!ni_dbus_xml_traverse(child->type, child->name,
+				path, context))
+			return FALSE;
+	}
+
+	return TRUE;
+}
+
+static dbus_bool_t
+ni_dbus_xml_traverse(const ni_xs_type_t *type, const char *name,
+		const ni_dbus_xml_traverse_path_t *prev,
+		ni_dbus_xml_traverse_context_t *context)
+{
+	const ni_dbus_xml_traverse_path_t path = { .prev = prev, .name = name };
+
+	if (!type || !name || !prev || !context || !context->process)
+		return FALSE;
+
+	if (!context->process(type, name, prev, context))
+		return FALSE;
+
+	switch (type->class) {
+	case NI_XS_TYPE_VOID:
+	case NI_XS_TYPE_SCALAR:
+		return TRUE;
+
+	case NI_XS_TYPE_STRUCT:
+		return ni_dbus_xml_traverse_struct(type, name, &path, context);
+
+	case NI_XS_TYPE_UNION:
+		return ni_dbus_xml_traverse_union(type, name, &path, context);
+
+	case NI_XS_TYPE_ARRAY:
+		return ni_dbus_xml_traverse_array(type, name, &path, context);
+
+	case NI_XS_TYPE_DICT:
+		return ni_dbus_xml_traverse_dict(type, name, &path, context);
+
+	default:
+		ni_error("unsupported xml type class %u", type->class);
+		return FALSE;
+	}
+	return TRUE;
+}
+
+const char *
+ni_dbus_xml_traverse_path_print(ni_stringbuf_t *buf,
+		const ni_dbus_xml_traverse_path_t *path)
+{
+	if (!buf || !path || !path->name)
+		return NULL;
+
+	if (path->prev)
+		ni_dbus_xml_traverse_path_print(buf, path->prev);
+
+	ni_stringbuf_puts(buf, "/");
+	ni_stringbuf_puts(buf, path->name);
+
+	return buf->string;
+}
+
+
+dbus_bool_t
+ni_dbus_xml_traverse_service_properties(const ni_dbus_service_t *service,
+		ni_dbus_xml_traverse_context_t *context)
+{
+	ni_dbus_xml_traverse_path_t path;
+	const ni_xs_service_t *xs_service;
+	const ni_xs_scope_t *xs_scope;
+	const ni_xs_type_t *xs_type;
+	const char *interface;
+
+	if (!service || !service->schema || !service->schema->interface)
+		return FALSE;
+
+	if (!(xs_scope = ni_objectmodel_init(NULL)))
+		return FALSE;
+
+	interface = service->schema->interface;
+	if (!(xs_service = ni_dbus_xml_get_service_schema(xs_scope, interface)))
+		return FALSE;
+
+	if (!(xs_type = ni_dbus_xml_get_properties_schema(xs_scope, xs_service)))
+		return FALSE;
+
+	/* xs service name as "root" path */
+	path.prev = NULL;
+	path.type = NULL;
+	path.name = service->schema->name;
+
+	return ni_dbus_xml_traverse(xs_type, "properties", &path, context);
+}
+
 /*
  * A different entry point for ni_xs_type_to_dbus_signature
  */
diff --git a/src/fsm-policy.c b/src/fsm-policy.c
index 86c2a05cf..b19975902 100644
--- a/src/fsm-policy.c
+++ b/src/fsm-policy.c
@@ -955,13 +955,16 @@ ni_fsm_template_input_free(ni_fsm_template_input_t *input)
 static void
 ni_fsm_policy_action_xml_lookup_next(xml_node_t *node, const char *name, xml_node_array_t *res)
 {
-	xml_node_t *child;
+	xml_node_t *child, *ref;
 	unsigned int found = 0;
 
 	for (child = node->children; child; child = child->next) {
 		if (ni_string_eq(child->name, name)) {
-			if (!child->final)
-				xml_node_array_append(res, child);
+			if (!child->final) {
+				ref = xml_node_clone_ref(child);
+				if (ref && !xml_node_array_append(res, ref))
+					xml_node_free(ref);
+			}
 			found++;
 		}
 	}
@@ -975,14 +978,21 @@ ni_fsm_policy_action_xml_lookup(xml_node_t *node, const char *path)
 {
 	xml_node_array_t *cur;
 	char *copy, *name;
+	xml_node_t *ref;
 
 	if (node->final) {
 		ni_error("%s: called with XML element that's marked final", __func__);
 		return NULL;
 	}
 
-	cur = xml_node_array_new();
-	xml_node_array_append(cur, node);
+	if (!(cur = xml_node_array_new()))
+		return NULL;
+
+	ref = xml_node_clone_ref(node);
+	if (ref && !xml_node_array_append(cur, ref)) {
+		xml_node_free(ref);
+		return NULL;
+	}
 
 	copy = strdup(path);
 	for (name = strtok(copy, "/"); name && cur->count; name = strtok(NULL, "/")) {
